Bug 1679565 - a tcp server is blocked forever when it is trying to read the data less than SO_RCVLOWAT even though client has sent that much data.
Summary: a tcp server is blocked forever when it is trying to read the data less than ...
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: net6
Version: 29
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Orphan Owner
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-02-21 12:29 UTC by Pawan
Modified: 2019-11-27 21:08 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-11-27 21:08:47 UTC
Type: Bug


Attachments (Terms of Use)

Description Pawan 2019-02-21 12:29:55 UTC
Description of problem:

a tcp server is blocked forever when it is trying to read the data less than SO_RCVLOWAT even though client has sent that much data. Just to take an example if SO_RCVLOWAT is set to 80 byte and server is trying to read 20 byte of data and blocked on read/recv syscall and hen client is sending 20+ bytes of data, the server is never coming out of that block recv/read syscall unless we close the connection from the client side.

Version-Release number of selected component (if applicable):

$ uname -a
Linux block1 4.20.3-200.fc29.x86_64 #1 SMP Thu Jan 17 15:19:35 UTC 2019 x86_64 x86_64 x86_64 GNU/Linux

$ cat /etc/redhat-release
Fedora release 29 (Twenty Nine)

How reproducible:

It's easily reproducible by using below sample test server and client :-

https://github.com/pawanpraka1/gist

Steps to Reproduce:
1.start client and server, with client having a sleep of 1s before sending the packet.
2.server requests 20 bytes and will be blocked as client has not sent anything
3.client sends 23 bytes
4. server is not coming out of the blocked state

Actual results:

server is blocked forever unless client closes the connection.

Expected results:

since server is asking for 20 bytes of data only, and client has sent that much of data, it should come out of blocked call. This is working fine on ubuntu machine, and redhat machine.


Additional info:

Comment 1 Ben Cotton 2019-10-31 19:56:17 UTC
This message is a reminder that Fedora 29 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 29 on 2019-11-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '29'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 29 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 2 Ben Cotton 2019-11-27 21:08:47 UTC
Fedora 29 changed to end-of-life (EOL) status on 2019-11-26. Fedora 29 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.